=== debian/changelog ===
wasi-libc (0.0~git20250726.3f7eb4c-4) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 26 Dec 2025 20:55:54 +0100

wasi-libc (0.0~git20250726.3f7eb4c-3) experimental; urgency=medium

  * upgrade to LLVM 21

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 28 Nov 2025 17:34:13 +0100

wasi-libc (0.0~git20250726.3f7eb4c-2) unstable; urgency=medium

  * update d/copyright

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Sat, 25 Oct 2025 15:47:20 +0200

wasi-libc (0.0~git20250726.3f7eb4c-1) experimental; urgency=medium

  * new upstream release for rustc 1.90.0
  * cherry-pick wasi-p2 build fix from upstream
  * build: fix compiler-rt linkage

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 15 Oct 2025 13:44:31 +0200
