=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/buildflags.mk

export NM = llvm-nm-21
export AR = llvm-ar-21
export CC = clang-21

export BUILTINS_LIB = /usr/lib/llvm-21/lib/clang/21/lib/wasi/libclang_rt.builtins-wasm32.a

# stack protector not yet supported, see
# https://github.com/CraneStation/wasi-libc/issues/157
# https://bugs.debian.org/1051815
export EXTRA_CFLAGS = $(CFLAGS) $(LDFLAGS) -fno-stack-protector -fcf-protection=none

%:
	dh $@

.PHONY: build
build:
	dh $@

override_dh_auto_build:
	dh_auto_build -- finish
	dh_auto_build -- WASI_SNAPSHOT=p2 finish

override_dh_auto_install:
	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr
	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr WASI_SNAPSHOT=p2
